Bug 1464781 - Unable to add remote/guest node forcibly to a cluster if error with pacmeaker_remote daemon occurs on remote/guest node
Unable to add remote/guest node forcibly to a cluster if error with pacmeaker...
Status: ASSIGNED
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: pcs (Show other bugs)
7.4
Unspecified Unspecified
high Severity unspecified
: rc
: ---
Assigned To: Ivan Devat
cluster-qe@redhat.com
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-25 13:07 EDT by Miroslav Lisik
Modified: 2017-12-15 12:45 EST (History)
5 users (show)

See Also:
Fixed In Version: pcs-0.9.160-1.el7
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
proposed fix (17.28 KB, patch)
2017-06-30 10:36 EDT, Tomas Jelinek
no flags Details | Diff

  None (edit)
Description Miroslav Lisik 2017-06-25 13:07:13 EDT
Description of problem:

Unable to add remote/guest node forcibly to a cluster when pacemaker-remote
package is not installed or if some error occurs during enable and start
actions of pacemaker_remote daemon on the remote/geust nodes.


Version-Release number of selected component (if applicable):
pcs-0.9.158-6.el7


How reproducible:
always


Steps to Reproduce:

1. Have a cluster authenticated against remote or guest node.

2. Make sure that package pacemaker-remote is not installed or cause error
somehow during start/enable of pcemaker_remote daemon.

3. Issue the command for adding remote/guest node.


Actual results:

Adding remote node without forcing works as expected:

[root@duck-01 ~]# pcs cluster node add-remote virt-136
Sending remote node configuration files to 'virt-136'
virt-136: successful distribution of the file 'pacemaker_remote authkey'
Requesting start of service pacemaker_remote on 'virt-136'
Error: virt-136: service command failed: pacemaker_remote start: Operation failed., use --force to override
Error: virt-136: service command failed: pacemaker_remote enable: Operation failed., use --force to override
[root@duck-01 ~]# echo $?
1
[root@duck-01 ~]# pcs status nodes | sed -n '/Pacemaker Remote/,$ p'
Pacemaker Remote Nodes:
 Online:
 Standby:
 Maintenance:
 Offline:

Adding remote node with forcing does not work:

[root@duck-01 ~]# pcs cluster node add-remote virt-136 --force
Sending remote node configuration files to 'virt-136'
virt-136: successful distribution of the file 'pacemaker_remote authkey'
Requesting start of service pacemaker_remote on 'virt-136'
Error: virt-136: service command failed: pacemaker_remote start: Operation failed., use --force to override
Error: virt-136: service command failed: pacemaker_remote enable: Operation failed., use --force to override
[root@duck-01 ~]# echo $?
1
[root@duck-01 ~]# pcs status nodes | sed -n '/Pacemaker Remote/,$ p'
Pacemaker Remote Nodes:
 Online:
 Standby:
 Maintenance:
 Offline:

Adding guest node without forcing works as expected:

[root@duck-01 ~]# pcs cluster node add-guest pool-10-34-70-90 guest-01
Sending remote node configuration files to 'pool-10-34-70-90'
pool-10-34-70-90: successful distribution of the file 'pacemaker_remote authkey'
Requesting start of service pacemaker_remote on 'pool-10-34-70-90'
Error: pool-10-34-70-90: service command failed: pacemaker_remote start: Operation failed., use --force to override
Error: pool-10-34-70-90: service command failed: pacemaker_remote enable: Operation failed., use --force to override
[root@duck-01 ~]# echo $?
1
[root@duck-01 ~]# pcs status nodes | sed -n '/Pacemaker Remote/,$ p'
Pacemaker Remote Nodes:
 Online:
 Standby:
 Maintenance:
 Offline:

Adding guest node with forcing does not work:

[root@duck-01 ~]# pcs cluster node add-guest pool-10-34-70-90 guest-01 --force
Sending remote node configuration files to 'pool-10-34-70-90'
pool-10-34-70-90: successful distribution of the file 'pacemaker_remote authkey'
Requesting start of service pacemaker_remote on 'pool-10-34-70-90'
Error: pool-10-34-70-90: service command failed: pacemaker_remote start: Operation failed., use --force to override
Error: pool-10-34-70-90: service command failed: pacemaker_remote enable: Operation failed., use --force to override
[root@duck-01 ~]# echo $?
1
[root@duck-01 ~]# pcs status nodes | sed -n '/Pacemaker Remote/,$ p'
Pacemaker Remote Nodes:
 Online:
 Standby:
 Maintenance:
 Offline:


Expected results:

When remote/guest node is added forcibly, node is always added to a cluster
despite of failed actions on the remote/guest node.


Additional info:

Possible workaround: to use --skip-offline option, but it is not suggested in the error message.

[root@duck-01 ~]# pcs cluster node add-remote virt-136 --skip-offline
Sending remote node configuration files to 'virt-136'
virt-136: successful distribution of the file 'pacemaker_remote authkey'
Requesting start of service pacemaker_remote on 'virt-136'
Warning: virt-136: service command failed: pacemaker_remote start: Operation failed.
Warning: virt-136: service command failed: pacemaker_remote enable: Operation failed.
[root@duck-01 ~]# echo $?
0
[root@duck-01 ~]# pcs status nodes | sed -n '/Pacemaker Remote/,$ p'
Pacemaker Remote Nodes:
 Online:
 Standby:
 Maintenance:
 Offline: virt-136

[root@duck-01 ~]# pcs cluster node add-guest pool-10-34-70-90 guest-01 --skip-offline
Sending remote node configuration files to 'pool-10-34-70-90'
pool-10-34-70-90: successful distribution of the file 'pacemaker_remote authkey'
Requesting start of service pacemaker_remote on 'pool-10-34-70-90'
Warning: pool-10-34-70-90: service command failed: pacemaker_remote start: Operation failed.
Warning: pool-10-34-70-90: service command failed: pacemaker_remote enable: Operation failed.
[root@duck-01 ~]# echo $?
0
[root@duck-01 ~]# pcs status nodes | sed -n '/Pacemaker Remote/,$ p'
Pacemaker Remote Nodes:
 Online:
 Standby:
 Maintenance:
 Offline: pool-10-34-70-90 virt-136
Comment 2 Tomas Jelinek 2017-06-30 10:36 EDT
Created attachment 1293252 [details]
proposed fix
Comment 4 Ivan Devat 2017-10-11 04:01:21 EDT
After Fix:

[vm-rhel72-1 ~] $ rpm -q pcs
pcs-0.9.160-1.el7.x86_64

[vm-rhel72-1 ~] $ pcs cluster node add-remote vm-rhel72-2 --force
Sending remote node configuration files to 'vm-rhel72-2'
vm-rhel72-2: successful distribution of the file 'pacemaker_remote authkey'
Requesting start of service pacemaker_remote on 'vm-rhel72-2'
Warning: vm-rhel72-2: service command failed: pacemaker_remote enable: Operation failed.
Warning: vm-rhel72-2: service command failed: pacemaker_remote start: Operation failed.

[vm-rhel72-1 ~] $ echo $?
0

Note You need to log in before you can comment on or make changes to this bug.